#include <stdio.h>
#include <string.h>
#include <math.h>

#define MAXLEN 9000

char *gettok()
{
	return(strtok(NULL,"{};, "));
}

main(argc, argv)

int argc;
char *argv[];

{
	int fcol, lcol, frow, lrow;
	int i, j, gwidth, fheight, gheight, width, pwidth, height, length;
	int gxpos, gypos, fullflag, softflag;

        char *filename=argv[1];
        char *options=argv[2];
	char symbol[29];
	char outfile[29];
	char cfile[29];
        FILE *stream, *fp, *cfp;
        char c, *s, *token, instr[MAXLEN], instr1[MAXLEN];
	char *gettok();


        if ((stream=fopen(filename,"r"))==NULL) {
                printf("File not found\n");
                return (1);
        }

	strncpy(symbol,argv[1],strcspn(argv[1],"."));
	strncpy(outfile,argv[1],strcspn(argv[1],"."));
	strncpy(cfile,argv[1],strcspn(argv[1],"."));
	strcat(outfile,".s");
	strcat(cfile,".cbm");
	softflag=(options[0]=='S');
	fullflag=(options[0]=='F');

	i=0;
        while ((c = getc(stream)) != EOF) {
		instr[i]=c;
		instr1[i]=c;
		if (c=='\n') {
			instr[i]=' ';
			instr1[i]=' ';
		}
		i++;
	}

	token=strtok(instr,"{};# ");		/* Start reading stream */

	token=gettok();		/* Skip *_width */

	s=gettok();		/* Read width token */
	pwidth=atoi(s);		/* Width of picture in pixels */
	width=pwidth/8;		/* Width of picture in bytes */
	if (width*8 < pwidth) width++;

	token=gettok();		/* Skip #define */
	token=gettok();		/* Skip *_height */

	s=gettok();		/* Read height token */
	height=atoi(s);		/* Number of rows */
	fheight=height;
	if (!softflag && height>56) height=56;

	token=gettok();		/* Skip static */
	token=gettok();		/* Skip char */
	token=gettok();		/* Skip *_bits[] */
	token=gettok();		/* Skip = */

	frow=999; fcol=999; lrow=1; lcol=1;
	for (i=1; i<=height; i++) {
		for (j=1; j<=width; j++) {
			token=gettok();
			token++;	/* Skip past the   */
			token++;	/* 0x in the token */
			if (token[0]!='0' || token[1]!='0') {
			  if (i<frow) frow=i;
			  if (i>lrow) lrow=i;
			  if (j<fcol) fcol=j;
			  if (j>lcol) lcol=j;
			}
		}
	}

	gwidth=(lcol-fcol+1)*8;
	gheight=(lrow-frow+1);

	if (fullflag) { frow=1; lrow=fheight; fcol=1; lcol=131;
			gwidth=131; gheight=fheight; height=fheight; width=17; }

	gxpos=(fcol-1)*8;
	gypos=frow-1;				/* Opt. base zero coords */

	token=strtok(instr1,"{};# ");		/* Start reading stream */
	for (i=1; i<=9; i++) token=gettok(); 	/* Skip to start of data */

	fp=fopen(outfile,"w");
	cfp=fopen(cfile,"w");

	fprintf(cfp,"#define %s_width %d\n",symbol,gwidth);
	fprintf(cfp,"#define %s_height %d\n",symbol,gheight);
	fprintf(cfp,"static char %s_bits[] = {\n",symbol);

	fprintf(fp,"INCLUDE ./%c%cRomId.h\n",symbol[0],symbol[1]);
	fprintf(fp,"INCLUDE ./%c%cExtDecl.h\n",symbol[0],symbol[1]);
	fprintf(fp,"NULLNAME %s\n",symbol);
	if (!fullflag) fprintf(fp,"{ %d %d\n",gxpos,gypos);
	fprintf(fp,"ASSEMBLE\n");
	fprintf(fp,"        CON(5)  =DOGROB\n");
	fprintf(fp,"        REL(5)  e%s\n",symbol);	/* Length */
	fprintf(fp,"        CON(5)  %d\n",gheight);  	/* Height */
	fprintf(fp,"        CON(5)  %d\n",gwidth);		/* Width  */

	for (i=1; i<=height; i++) {
		for (j=1; j<=width; j++) {
			token=gettok();
			token++;	/* Skip past the   */
			token++;	/* 0x in the token */
			if (i>=frow && i<=lrow && j>=fcol && j<=lcol ) {
			  fprintf(fp,"        NIBHEX  %c%c\n",token[1],token[0]);
			  fprintf(cfp,"        0x%c%c,\n",token[0],token[1]);
			}
		}
	}
	fprintf(fp,"e%s\n",symbol);	/* End equate for REL */
	fprintf(fp,"RPL\n");
	if (!fullflag) fprintf(fp,"}\n");

	fprintf(cfp,"}\n");

	return(0);
}
