#include <stdio.h>
#include <conio.h>

double horner(double x, long coefs[]);

main() {

  long coefs[8],x;
  double diffs[8][8],x1,y;
  int i,j,order;
  char buffer[180];

  for(i=0;i<8;i++) coefs[i]=0;
  for(i=0;i<8;i++) for(j=0;j<8;j++) diffs[i][j]=0;
  while(1) {
    printf( "Enter order of polynomial (2-7)? ");
    scanf("%s",buffer);
    sscanf(buffer,"%d",&order);
    printf("\n");
    if((order>1) && (order<8)) break;
  }

  printf("Enter constant: ");
  scanf("%s",&buffer);
  sscanf(buffer,"%ld",&coefs[0]);

  for(i=1;i<=order;i++) {
    printf("Enter coefficient of %d",i);
    switch (i) {
      case 1: printf("st"); break;
      case 2: printf("nd"); break;
      case 3: printf("rd"); break;
      case 4: printf("th"); break;
      case 5: printf("th"); break;
      case 6: printf("th"); break;
      case 7: printf("th"); break;
    }
    printf(" order term: ");
    scanf("%s",&buffer);
    sscanf(buffer,"%ld",&coefs[i]);
  }

  printf("\n");
  printf("\nY=");
  for(i=order;i>=1;i--) {
    if((i==order) && ((coefs[i]<-1) || (coefs[i]>1)))
      printf("%ld*X^%d",coefs[i],i);
    else if(coefs[i]!=0) {
      if((coefs[i]<-1) || (coefs[i]>1)) printf("%+ld*",coefs[i]);
      else {
	if(coefs[i]==-1)
	  printf("-");
	else
	  if(i!=order) printf("+");
      }
      if(i>1) printf("X^%d",i); else printf("X");
    }
  }
  printf("%+d\n",coefs[0]);

  printf("\nStarting value for X? ");
  scanf("%s",&buffer);
  sscanf(buffer,"%ld",&x);
  printf("\n");
  x1=(double)x-7.;
  for(i=0;i<8;i++) {
    y=horner(x1,coefs);
    diffs[0][i]=y;
    x1++;
  }

  for(i=1;i<8;i++)
    for(j=1;j<8;j++)
      diffs[i][j]=diffs[i-1][j]-diffs[i-1][j-1];
  for(i=order;i>0;i--)
    printf("d%d: %-.lf\n",i,diffs[i][7]);
  printf(" T: %-.lf\n",y);

}

double horner(double x, long coefs[])
{
  double y;

/*  y=((((((coefs[7]*x)+coefs[6])*x)+coefs[5])*x)+coefs[4])*x; */
/*  y=((((((y+coefs[3])*x)+coefs[2])*x)+coefs[1])*x)+coefs[0]; */

  y=(double)coefs[7]*x;
  y=(y+(double)coefs[6])*x;
  y=(y+(double)coefs[5])*x;
  y=(y+(double)coefs[4])*x;
  y=(y+(double)coefs[3])*x;
  y=(y+(double)coefs[2])*x;
  y=(y+(double)coefs[1])*x;
  y=y+(double)coefs[0];

  return y;
}
